import firebase from 'firebase/app';
import 'firebase/firestore';
import { DocumentData } from './utils';
import 'core-js/fn/array/includes';
import 'core-js/fn/number/is-nan';
export declare const DOCUMENT_KEY_NAME = "__name__";
export declare class FireSQL {
    private _ref?;
    private _path?;
    private _options;
    constructor(refOrOptions?: FirestoreOrDocOrOptions, options?: FireSQLOptions);
    readonly ref: firebase.firestore.DocumentReference;
    readonly firestore: firebase.firestore.Firestore;
    readonly options: FireSQLOptions;
    query(sql: string, options?: QueryOptions): Promise<DocumentData[]>;
    query<T>(sql: string, options?: QueryOptions): Promise<T[]>;
    private _getRef;
    toJSON(): object;
}
export interface FireSQLOptions {
    includeId?: boolean | string;
}
export interface QueryOptions extends FireSQLOptions {
}
export declare type FirestoreOrDocument = string | firebase.firestore.Firestore | firebase.firestore.DocumentReference;
export declare type FirestoreOrDocOrOptions = FirestoreOrDocument | FireSQLOptions;
/**
 * @deprecated Class FirestoreSQL has been renamed FireSQL
 */
export declare class FirestoreSQL extends FireSQL {
    constructor(ref?: string | firebase.firestore.Firestore | firebase.firestore.DocumentReference);
}
